/*
*        Automata_Generator v0.2
*         Automata.h
* 
*/

#include "ag_base.h"
#include "iostream"
#include "GlobalDataModel.h"
#include "insertDataModel.h"
#include "mainDataModel.h"


GlobalDataModel* globalData = new GlobalDataModel();



void stepForward(int steps);
void stepBackward(int steps);
void toStart();
void toEnd();
string printVar(const string& name);
int getStateNumber();

AutomatonBase *getCurrentAutomaton();
string getCurrentAutomatonName();

class insertAutomaton: public AutomatonBase
{
	insertDataModel *data;
public:
	insertAutomaton(int n);
	~insertAutomaton();

	virtual void stepForward(int stepNumber = 1);
	virtual void stepBackward(int stepNumber = 1);

    std::string getVariable(const std::string &varName)
    {
		return data->getVariable(varName);
    }

};

insertAutomaton::~insertAutomaton()
{
	delete data;
}

insertAutomaton::insertAutomaton(int n) : AutomatonBase(17,"insert")
{
	data = new insertDataModel;
	data->n = n;
	statePriorities_[0] = 100;
	statePriorities_[1] = 100;
	statePriorities_[2] = 101;
	statePriorities_[3] = 100;
	statePriorities_[4] = 100;
	statePriorities_[5] = 100;
	statePriorities_[6] = 101;
	statePriorities_[7] = 100;
	statePriorities_[8] = 100;
	statePriorities_[9] = 100;
	statePriorities_[10] = 101;
	statePriorities_[11] = 100;
	statePriorities_[12] = 100;
	statePriorities_[13] = 100;
	statePriorities_[14] = 100;
	statePriorities_[15] = 101;
	statePriorities_[16] = 100;
}



void insertAutomaton::stepForward(int stepNumber)
{
	//First, follow transition from current to next state 
	switch(currentState_){
		case 0: 
			{
				 setState(1);
			} 
		break; 
		case 1: 
			{
				 setState(2);
			} 
		break; 
		case 2: 
			{
				 setState(3);
			} 
		break; 
		case 3: 
			if(!(data->i<8))
			{
				 setState(15);
			} 
			if(data->i<8)
			{
				 setState(4);
			} 
		break; 
		case 4: 
			if(data->n<globalData->sorted[data->i])
			{
				 setState(5);
			} 
			if(!(data->n<globalData->sorted[data->i]))
			{
				 setState(12);
				stack_->push(false);
			} 
		break; 
		case 5: 
			{
				 setState(6);
			} 
		break; 
		case 6: 
			{
				 setState(7);
			} 
		break; 
		case 7: 
			if(!(data->k>=data->i))
			{
				 setState(10);
			} 
			if(data->k>=data->i)
			{
				 setState(8);
			} 
		break; 
		case 8: 
			{
				 setState(9);
			} 
		break; 
		case 9: 
			{
				 setState(7);
			} 
			stack_->push(true);
		break; 
		case 10: 
			{
				 setState(11);
			} 
		break; 
		case 11: 
			{
				 setState(12);
			} 
			stack_->push(true);
		break; 
		case 12: 
			{
				 setState(13);
			} 
		break; 
		case 13: 
			{
				 setState(14);
			} 
		break; 
		case 14: 
			{
				 setState(3);
			} 
			stack_->push(true);
		break; 
		case 15: 
			{
				 setState(16);
			} 
			stack_->push(15);
		break; 
		case 16: 
		break; 
		default:
			//Enter some error notification code here 
		break; 
	} 
//Now do all necessary actions in the state. 
	switch(currentState_){
		case 0: 
		break; 
		case 1: 
		stack_->setPushesAssumed(1);
			stack_->push(&data->i, sizeof(data->i)); 
			data->i = 0; 
		break; 
		case 2: 
			stack_->push(false); 
		break; 
		case 3: 
		break; 
		case 4: 
		break; 
		case 5: 
		stack_->setPushesAssumed(1);
			stack_->push(&data->k, sizeof(data->k)); 
			data->k = 6; 
		break; 
		case 6: 
			stack_->push(false); 
		break; 
		case 7: 
		break; 
		case 8: 
		stack_->setPushesAssumed(2);
			stack_->push(&globalData->sorted[data->k+1], sizeof(globalData->sorted[data->k+1])); 
			globalData->sorted[data->k+1] = globalData->sorted[data->k]; 
			stack_->push(&data->k, sizeof(data->k)); 
			data->k--; 
		break; 
		case 9: 
		break; 
		case 10: 
		break; 
		case 11: 
		stack_->setPushesAssumed(1);
			stack_->push(&globalData->sorted[data->i], sizeof(globalData->sorted[data->i])); 
			globalData->sorted[data->i] = data->n; 
		break; 
		case 12: 
		break; 
		case 13: 
		stack_->setPushesAssumed(1);
			stack_->push(&data->i, sizeof(data->i)); 
			data->i++; 
		break; 
		case 14: 
		break; 
		case 15: 
		break; 
		case 16: 
		break; 
		default:
			//Enter some error notification code here 
		break; 
	}

	
	if(statePriorities_[currentState_] == PRIORITY_NO_STOP && (child_ == NULL || child_->isAtEnd())) {
		stepForward();
	}
}

void insertAutomaton::stepBackward(int stepNumber)
{
		switch(currentState_){
		case 0: 
		break; 
		case 1: 
			stack_->pop(&data->i); 
		break; 
		case 2: 
		break; 
		case 3: 
		break; 
		case 4: 
		break; 
		case 5: 
			stack_->pop(&data->k); 
		break; 
		case 6: 
		break; 
		case 7: 
		break; 
		case 8: 
			stack_->pop(&data->k); 
			stack_->pop(&globalData->sorted[data->k+1]); 
		break; 
		case 9: 
		break; 
		case 10: 
		break; 
		case 11: 
			stack_->pop(&globalData->sorted[data->i]); 
		break; 
		case 12: 
		break; 
		case 13: 
			stack_->pop(&data->i); 
		break; 
		case 14: 
		break; 
		case 15: 
		break; 
		case 16: 
		break; 
		default:
			//Enter some error notification code here 
		break; 
	} 
//Now step one state back 
	switch(currentState_){
		case 0: 
		break; 
		case 1: 
			{
				 setState(0);
			} 
		break; 
		case 2: 
			{
				 setState(1);
			} 
		break; 
		case 3: 
			if(stack_->popBool())
			{
				 setState(14);
				break;
			} 
			{
				 setState(2);
			} 
		break; 
		case 4: 
			{
				 setState(3);
			} 
		break; 
		case 5: 
			{
				 setState(4);
			} 
		break; 
		case 6: 
			{
				 setState(5);
			} 
		break; 
		case 7: 
			if(stack_->popBool())
			{
				 setState(9);
				break;
			} 
			{
				 setState(6);
			} 
		break; 
		case 8: 
			{
				 setState(7);
			} 
		break; 
		case 9: 
			{
				 setState(8);
			} 
		break; 
		case 10: 
			{
				 setState(7);
			} 
		break; 
		case 11: 
			{
				 setState(10);
			} 
		break; 
		case 12: 
			{
				 setState(11);
			} 
			if(!(stack_->popBool()))
			{
				 setState(4);
				break;
			} 
		break; 
		case 13: 
			{
				 setState(12);
			} 
		break; 
		case 14: 
			{
				 setState(13);
			} 
		break; 
		case 15: 
			{
				 setState(3);
			} 
		break; 
		case 16: 
			{
				 setState(stack_->popInt());
			} 
		break; 
		default:
			//Enter some error notification code here 
		break; 
	} 

	if(statePriorities_[currentState_] == PRIORITY_NO_STOP && (child_ == NULL || child_->isAtEnd())) {
		stepBackward();
	}
}
class mainAutomaton: public AutomatonBase
{
	mainDataModel *data;
public:
	mainAutomaton();
	~mainAutomaton();

	virtual void stepForward(int stepNumber = 1);
	virtual void stepBackward(int stepNumber = 1);

    std::string getVariable(const std::string &varName)
    {
		return data->getVariable(varName);
    }

};

mainAutomaton::~mainAutomaton()
{
	delete data;
}

mainAutomaton::mainAutomaton() : AutomatonBase(15,"main")
{
	data = new mainDataModel;
	statePriorities_[0] = 100;
	statePriorities_[1] = 100;
	statePriorities_[2] = 101;
	statePriorities_[3] = 100;
	statePriorities_[4] = 100;
	statePriorities_[5] = 100;
	statePriorities_[6] = 101;
	statePriorities_[7] = 100;
	statePriorities_[8] = 101;
	statePriorities_[9] = 100;
	statePriorities_[10] = 101;
	statePriorities_[11] = 100;
	statePriorities_[12] = 100;
	statePriorities_[13] = 101;
	statePriorities_[14] = 100;
}



void mainAutomaton::stepForward(int stepNumber)
{
	//First, follow transition from current to next state 
	switch(currentState_){
		case 0: 
			{
				 setState(1);
			} 
		break; 
		case 1: 
			{
				 setState(2);
			} 
		break; 
		case 2: 
			{
				 setState(3);
			} 
		break; 
		case 3: 
			if(!(data->i>=0))
			{
				 setState(6);
			} 
			if(data->i>=0)
			{
				 setState(4);
			} 
		break; 
		case 4: 
			{
				 setState(5);
			} 
		break; 
		case 5: 
			{
				 setState(3);
			} 
			stack_->push(true);
		break; 
		case 6: 
			{
				 setState(7);
			} 
		break; 
		case 7: 
			{
				 setState(8);
			} 
		break; 
		case 8: 
			{
				 setState(9);
			} 
		break; 
		case 9: 
			if(!(data->i>=0))
			{
				 setState(13);
			} 
			if(data->i>=0)
			{
				 setState(10);
			} 
		break; 
		case 10: 
			if(!(child_->isAtEnd()))
			{
				 setState(10);
			} 
			if(child_->isAtEnd())
			{
				 setState(11);
				child_ = NULL;
			} 
		break; 
		case 11: 
			{
				 setState(12);
			} 
		break; 
		case 12: 
			{
				 setState(9);
			} 
			stack_->push(true);
		break; 
		case 13: 
			{
				 setState(14);
			} 
			stack_->push(13);
		break; 
		case 14: 
		break; 
		default:
			//Enter some error notification code here 
		break; 
	} 
//Now do all necessary actions in the state. 
	switch(currentState_){
		case 0: 
		break; 
		case 1: 
		stack_->setPushesAssumed(9);
			stack_->push(&data->i, sizeof(data->i)); 
			data->i = 7; 
			stack_->push(&globalData->array[0], sizeof(globalData->array[0])); 
			globalData->array[0] = 1; 
			stack_->push(&globalData->array[1], sizeof(globalData->array[1])); 
			globalData->array[1] = 2; 
			stack_->push(&globalData->array[2], sizeof(globalData->array[2])); 
			globalData->array[2] = 5; 
			stack_->push(&globalData->array[3], sizeof(globalData->array[3])); 
			globalData->array[3] = 4; 
			stack_->push(&globalData->array[4], sizeof(globalData->array[4])); 
			globalData->array[4] = 3; 
			stack_->push(&globalData->array[5], sizeof(globalData->array[5])); 
			globalData->array[5] = 7; 
			stack_->push(&globalData->array[6], sizeof(globalData->array[6])); 
			globalData->array[6] = 9; 
			stack_->push(&globalData->array[7], sizeof(globalData->array[7])); 
			globalData->array[7] = 2; 
		break; 
		case 2: 
			stack_->push(false); 
		break; 
		case 3: 
		break; 
		case 4: 
		stack_->setPushesAssumed(2);
			stack_->push(&globalData->sorted[data->i], sizeof(globalData->sorted[data->i])); 
			globalData->sorted[data->i] = 1337; 
			stack_->push(&data->i, sizeof(data->i)); 
			data->i--; 
		break; 
		case 5: 
		break; 
		case 6: 
		break; 
		case 7: 
		stack_->setPushesAssumed(1);
			stack_->push(&data->i, sizeof(data->i)); 
			data->i = 7; 
		break; 
		case 8: 
			stack_->push(false); 
		break; 
		case 9: 
		break; 
		case 10: 
			if(child_ == NULL) {
															child_ = new insertAutomaton(globalData->array[data->i]);
															_childAutomata[currentState_].push_back(child_);
															child_->toStart();}; 
			child_->stepForward(); 
		break; 
		case 11: 
		stack_->setPushesAssumed(1);
			stack_->push(&data->i, sizeof(data->i)); 
			data->i--; 
		break; 
		case 12: 
		break; 
		case 13: 
		break; 
		case 14: 
		break; 
		default:
			//Enter some error notification code here 
		break; 
	}

	
	if(statePriorities_[currentState_] == PRIORITY_NO_STOP && (child_ == NULL || child_->isAtEnd())) {
		stepForward();
	}
}

void mainAutomaton::stepBackward(int stepNumber)
{
		switch(currentState_){
		case 0: 
		break; 
		case 1: 
			stack_->pop(&globalData->array[7]); 
			stack_->pop(&globalData->array[6]); 
			stack_->pop(&globalData->array[5]); 
			stack_->pop(&globalData->array[4]); 
			stack_->pop(&globalData->array[3]); 
			stack_->pop(&globalData->array[2]); 
			stack_->pop(&globalData->array[1]); 
			stack_->pop(&globalData->array[0]); 
			stack_->pop(&data->i); 
		break; 
		case 2: 
		break; 
		case 3: 
		break; 
		case 4: 
			stack_->pop(&data->i); 
			stack_->pop(&globalData->sorted[data->i]); 
		break; 
		case 5: 
		break; 
		case 6: 
		break; 
		case 7: 
			stack_->pop(&data->i); 
		break; 
		case 8: 
		break; 
		case 9: 
		break; 
		case 10: 
			if(child_ == NULL){ 
																			child_ = _childAutomata[currentState_][_childAutomata[currentState_].size() - 1];
																			_childAutomata[currentState_].pop_back(); child_->toEnd();
																			}; 
			child_->stepBackward(); 
		break; 
		case 11: 
			stack_->pop(&data->i); 
		break; 
		case 12: 
		break; 
		case 13: 
		break; 
		case 14: 
		break; 
		default:
			//Enter some error notification code here 
		break; 
	} 
//Now step one state back 
	switch(currentState_){
		case 0: 
		break; 
		case 1: 
			{
				 setState(0);
			} 
		break; 
		case 2: 
			{
				 setState(1);
			} 
		break; 
		case 3: 
			if(stack_->popBool())
			{
				 setState(5);
				break;
			} 
			{
				 setState(2);
			} 
		break; 
		case 4: 
			{
				 setState(3);
			} 
		break; 
		case 5: 
			{
				 setState(4);
			} 
		break; 
		case 6: 
			{
				 setState(3);
			} 
		break; 
		case 7: 
			{
				 setState(6);
			} 
		break; 
		case 8: 
			{
				 setState(7);
			} 
		break; 
		case 9: 
			if(stack_->popBool())
			{
				 setState(12);
				break;
			} 
			{
				 setState(8);
			} 
		break; 
		case 10: 
			if(!(child_->isAtStart()))
			{
				 setState(10);
			} 
			if(child_->isAtStart())
			{
				 setState(9);
				child_ = NULL;
			} 
		break; 
		case 11: 
			{
				 setState(10);
			} 
		break; 
		case 12: 
			{
				 setState(11);
			} 
		break; 
		case 13: 
			{
				 setState(9);
			} 
		break; 
		case 14: 
			{
				 setState(stack_->popInt());
			} 
		break; 
		default:
			//Enter some error notification code here 
		break; 
	} 

	if(statePriorities_[currentState_] == PRIORITY_NO_STOP && (child_ == NULL || child_->isAtEnd())) {
		stepBackward();
	}
}



AutomatonBase* main_automaton;
CAutoEnvironment env;

typedef bool REG_FUNC(const CAutoEnvironment *e);
typedef REG_FUNC *REG_FUNC_PTR;

typedef void CONTROL_FUNC();
typedef CONTROL_FUNC *CONTROL_FUNC_PTR;


//     
int main(int arc, char** argv)
{
	//Creating main automaton
	//  
	main_automaton = new mainAutomaton();
	
		
	//Initializing interaction structure for Tracer
	//     
	env.stepForward = &stepForward;
	env.stepBackward = &stepBackward;
	env.printVar = &printVar;
	env.getStateNumber = &getStateNumber;
	env.getCurrentAutomatonName = &getCurrentAutomatonName;
	env.toStart = &toStart;
	env.toEnd = &toEnd;
	
	//Loading Tracer dll
	//  
	HINSTANCE dllinst = LoadLibrary("tracer.dll");
	if (!dllinst)
	{
		unsigned int err = GetLastError();
		printf("Unable to load Tracer library! Error: %08x\n", err);
		return -1;
	}
	
	//Registering environment to Tracer
	//    
	REG_FUNC_PTR func;
	func = (REG_FUNC_PTR)GetProcAddress(dllinst, "registerEnvironment");
	if (func == NULL)
	{
		unsigned int err = GetLastError();
		printf("Tracer library loaded, but registerEnvironment function can not be found in it. Error: %08x\n", err);
		return -1;
	}
	func(&env);
	
	//Starting Tracer to control our environment
	// 
	CONTROL_FUNC_PTR control_func;
	control_func = (CONTROL_FUNC_PTR)GetProcAddress(dllinst, "startTracerControl");
	control_func();
	
	
	delete main_automaton;
	FreeLibrary(dllinst);
	
	
}

void stepForward(int steps)
{
	if(!main_automaton->isAtEnd())
		main_automaton->stepForward(steps);
}

void stepBackward(int steps)
{
	if(!main_automaton->isAtStart())
		main_automaton->stepBackward(steps);
}

void toStart()
{
	main_automaton->toStart();
}

void toEnd()
{
	main_automaton->toEnd();
}

string printVar(const string& name)
{
	string result = getCurrentAutomaton()->getVariable(name);
		if(result == "Unrecognized variable name.")return globalData->getVariable(name); 

	return result;
}

int getStateNumber()
{
	return getCurrentAutomaton()->getState();
}

AutomatonBase *getCurrentAutomaton()
{
	AutomatonBase *current = main_automaton;
	while (current->getChild() != NULL)
		current = current->getChild();
	return current;
}

string getCurrentAutomatonName()
{
	return getCurrentAutomaton()->getName();
}