#ifndef autoLog_h__
#define autoLog_h__

#include <string>

class Log
{
	const std::string _fileName;
	static Log* _instance;
	void initMessages();
public:
	Log():_fileName("AKlog.log") {
		initMessages();
		_instance = this;
	}
	enum LogLevel {
		MSG_REPORT = 0,
		MSG_WARNING,
		MSG_ERROR,
		MSG_FATAL
	};
	enum LogMode {
		MODE_CONSOLE = 0x1,
		MODE_FILE = 0x2,
	};
	static Log* getInstance(){ return _instance; } 
	void logMessage(LogLevel level, const std::string& subsystem, const std::string& message, LogMode target = MODE_CONSOLE);
};

void autoLog(Log::LogLevel level, const std::string& subsystem, const std::string& message);


#endif // autoLog_h__