#ifndef SkeletonParser_h__
#define SkeletonParser_h__

#include <fstream>
#include <vector>


namespace output {

typedef void SKELETON_GENERATOR(std::fstream&);
typedef SKELETON_GENERATOR *SKELETON_GENERATOR_PTR;

class CSkeletonParser;

class CKeyWord
{
	friend CSkeletonParser;
private:
	std::string word_;
	SKELETON_GENERATOR_PTR fun_;
public:
	CKeyWord();
	CKeyWord(std::string key, SKELETON_GENERATOR_PTR fun);
	~CKeyWord();

	//  
	int GetWordLength();
	bool CompareWord(std::string& chekingword);
};


class CSkeletonParser
{
public:
	//    
	CSkeletonParser();

	//  
	void parse(const char* in, const char* out);

	void registerKeyword(std::string key, SKELETON_GENERATOR_PTR fun);

	void parse(const char* in, std::fstream& out);

private:

	void startFunction(int number, std::fstream& out);
	void parse();
	//  
	std::vector<CKeyWord> keyWordsVector_;													//     
	std::fstream* in_;																		//  
	std::fstream* out_;																		//  
};


}
#endif // SkeletonParser_h__