#include <codegen/PDGBuilder.h>

bool outputPDGToFile( FILE* file, const slicing::ProgramDependencyGraph* graph )
{
   // fwrite(&slicing::ProgramDependencyGraph::magicNumber, sizeof(unsigned int), 1, file);
    
    const std::vector<slicing::GraphNode*>& nodes = graph->getNodes();

    unsigned int nodesSize = nodes.size();
    fwrite(&nodesSize, sizeof(unsigned int), 1, file);
    for (unsigned int i = 0; i < nodes.size(); ++i)
    {
        fwrite(&nodes[i]->lineStart, sizeof(int), 1, file);
        fwrite(&nodes[i]->lineEnd, sizeof(int), 1, file);
        fwrite(&nodes[i]->stateNumber, sizeof(int), 1, file);

        nodesSize = nodes[i]->controlDependentEdges.size();
        fwrite(&nodesSize, sizeof(int), 1, file);
        for (unsigned int j = 0; j < nodes[i]->controlDependentEdges.size(); ++j)
        {
            fwrite(&nodes[i]->controlDependentEdges[j], sizeof(int), 1, file);
        }

        nodesSize = nodes[i]->dataDependentEdges.size();
        fwrite(&nodesSize, sizeof(int), 1, file);
        for (unsigned int j = 0; j < nodes[i]->dataDependentEdges.size(); ++j)
        {
            fwrite(&nodes[i]->dataDependentEdges[j], sizeof(int), 1, file);
        }
    }


    return true;
}