#include <codegen/SkeletonParser.h>

using namespace output;


CSkeletonParser::CSkeletonParser()
{
	//in_.close();
	//out_.close();
}


void CSkeletonParser::parse(const char *in, const char *out)
{
	in_ = new std::fstream(in, std::ios_base::in);																//  
	out_ = new std::fstream(out, std::ios_base::out);

	parse();

	in_->close();																					//  
	out_->close();
	delete in_;
	delete out_;
}
void CSkeletonParser::parse(const char *in, std::fstream &out)
{
	in_ = new std::fstream(in, std::ios_base::in);	
	out_ = &out;

	parse();

	in_->close();
	delete in_;
}

void CSkeletonParser::parse()
{
	char ch;
	while(in_->get(ch))
	{
		if (ch == '$')																			//   
		{
			std::string tmp;
			in_->get(ch);
			while (ch != '$')																	//   
			{
				tmp += ch;
				in_->get(ch);
			}

			int markerNumber = -1;
			for (unsigned int i = 0; i < keyWordsVector_.size(); i++)									//       
			{
				if (tmp.size() == keyWordsVector_[i].GetWordLength())
					if (keyWordsVector_[i].CompareWord(tmp))
						markerNumber = i;
			}

			if (markerNumber > -1)
			{
				startFunction(markerNumber, *out_);
			}

		}
		else
		{
			out_->put(ch);
		}
	}

}

void CSkeletonParser::registerKeyword(std::string key, SKELETON_GENERATOR_PTR fun)
{	
	keyWordsVector_.push_back(CKeyWord(key, fun));																	//   	
}

void CSkeletonParser::startFunction(int number, std::fstream &out)
{
	keyWordsVector_[number].fun_(out);
}

//   

CKeyWord::CKeyWord()
{
	fun_ = NULL;
}

CKeyWord::~CKeyWord()
{

}

CKeyWord::CKeyWord(std::string key, SKELETON_GENERATOR_PTR fun)
{
	word_ = key;
	fun_ = fun;
}

int CKeyWord::GetWordLength()
{
	return word_.size();
}

bool CKeyWord::CompareWord(std::string& chekingword)
{
	for (unsigned int i = 0; i < word_.size(); i++)
		if (word_[i] != chekingword[i])
			return false;
	return true;
}

