#ifndef __SYNTAX_TREE_H__
#define __SYNTAX_TREE_H__
#include <string>

namespace common {

	struct SyntaxTreeNode
	{
		enum NodeType {
			NTYPE_SOMETHING = 0,
			NTYPE_PROGRAM,
			NTYPE_IF,
			NTYPE_OPERATOR,
			NTYPE_PROCEDURE,
			NTYPE_SEMICOLON,
			NTYPE_IF_WITH_ELSE,
			NTYPE_CONDITION,
			NTYPE_BRACKETS,
			NTYPE_WHILE,
			NTYPE_RETURN,
			NTYPE_KNOWN_FUNCTION_CALL,
			NTYPE_UNKNOWN_FUNCTION_CALL,
			NTYPE_VARIABLE_DECLARATION
		} _nodeType;
		
		// ,    
		int lineStart;
		int _StringNumber;
		int lineEnd;
			
		std::string _text;
		SyntaxTreeNode* _left;
		SyntaxTreeNode* _right;
		//           
		std::string _nameOfVariableToSave;
		std::string _typeOfVariableToSave;

        std::vector<std::string> changeSet; //variables affected by part of statement
        std::vector<std::string> dependsOn; //variables that this statement depends on

		SyntaxTreeNode(NodeType type, const std::string text, int line = 0, int start = 0, int end = 0):_nodeType(type),_text(text),_left(NULL),_right(NULL),_nameOfVariableToSave(""),_typeOfVariableToSave(""),_StringNumber(line), lineStart(start), lineEnd(end){}

	};

	
} //namespace common

#endif //__SYNTAX_TREE_H__