#include <qt/QFileDialog.h>

#include "tracer_v2.h"
#include "ADBProcessor/ADBProcessor.h"
#include "Logger.h"

Tracer_v2::Tracer_v2(QWidget *parent, Qt::WFlags flags)
    : QMainWindow(parent, flags)
{
    ui.setupUi(this);
    initConnections();
}

Tracer_v2::~Tracer_v2()
{

}

void Tracer_v2::outputDebugStr(const QString& str)
{
    ui.output->insertPlainText(str);
}

void Tracer_v2::openAutomatonDialog()
{
    QFileDialog dialog;
    QString adbFileName = dialog.getOpenFileName(this, "Load Automata Program", "", "*.adb");
    if (!adbProcessor.loadADBFile(adbFileName.toAscii())) {
        logger.logLine(Logger::MSG_ERROR, QString("Failed to load .adb file"));
        return;
    }
    
    automatonLibrary = LoadLibrary("output.dll"); //TODO: Fix it
    if (automatonLibrary == NULL) {
        logger.logLine(Logger::MSG_ERROR, QString("Failed to load automata program library"));
        return;
    }

}



void Tracer_v2::initConnections()
{
    QObject::connect(ui.actionLoad_Automaton, SIGNAL(activated()), this, SLOT(openAutomatonDialog()));
    QObject::connect(ui.actionClose_Automaton, SIGNAL(activated()), this, SLOT(unloadAutomaton()));
}

void Tracer_v2::unloadAutomaton()
{
    adbProcessor.unloadADBFile();
}